function ajax(url, type, body = '', isFile = false) {
	let contentType = 'application/x-www-form-urlencoded; charset=UTF-8';
	let processData = true;
	let data = { body };
	
	if(isFile){
		contentType = false;
		processData = false;
		data = body;
	}

	return new Promise((resolve, reject) => {
        $.ajax({
            url: url,
            type: type,
			contentType: contentType,
			processData: processData,
            headers: { 'X-CSRF-TOKEN': $('meta[name="X-CSRF-TOKEN"]').attr('content') },
            data: data,
            success: resolve,
            error: reject
        })
    })
}

function serialize (data) {
	let obj = {};
	for (let [key, value] of data) {
		if (obj[key] !== undefined) {
			if (!Array.isArray(obj[key])) {
				obj[key] = [obj[key]];
			}
			obj[key].push(value);
		} else {
			obj[key] = value;
		}
	}
	return obj;
}