const wheel = document.getElementById("wheel");
const inserSpin = document.getElementById("spin");
const finalValue = document.getElementById("final-value");
const code = document.getElementById("code");
const btnSpin = document.getElementById("spin-btn");
const player = document.getElementById("play");

$(window).on("load", function () {
  $("#kt_info").modal("show");
});

let musicAudio = new Audio(location + "/assets/media/spin/home.wav");
function music(param) {
  musicAudio.playbackRate = 0.8;
  if (param == "start") {
    musicAudio.play();
  } else {
    musicAudio.pause();
  }
}

player.addEventListener("click", () => {
  music("start");
});

var maxParticleCount = 400;
var particleSpeed = 2;
var startConfetti;
var stopConfetti;
var toggleConfetti;
var removeConfetti;

(function () {
  startConfetti = startConfettiInner;
  stopConfetti = stopConfettiInner;
  toggleConfetti = toggleConfettiInner;
  removeConfetti = removeConfettiInner;
  var colors = [
    "DodgerBlue",
    "OliveDrab",
    "Gold",
    "Pink",
    "SlateBlue",
    "LightBlue",
    "Violet",
    "PaleGreen",
    "SteelBlue",
    "SandyBrown",
    "Chocolate",
    "Crimson",
  ];
  var streamingConfetti = false;
  var animationTimer = null;
  var particles = [];
  var waveAngle = 0;

  function resetParticle(particle, width, height) {
    particle.color = colors[(Math.random() * colors.length) | 0];
    particle.x = Math.random() * width;
    particle.y = Math.random() * height - height;
    particle.diameter = Math.random() * 10 + 5;
    particle.tilt = Math.random() * 10 - 10;
    particle.tiltAngleIncrement = Math.random() * 0.05 + 0.05;
    particle.tiltAngle = 0;
    return particle;
  }

  function startConfettiInner() {
    var width = window.innerWidth;
    var height = window.innerHeight;
    window.requestAnimFrame = (function () {
      return (
        window.requestAnimationFrame ||
        window.webkitRequestAnimationFrame ||
        window.mozRequestAnimationFrame ||
        window.oRequestAnimationFrame ||
        window.msRequestAnimationFrame ||
        function (callback) {
          return window.setTimeout(callback, 16.6666667);
        }
      );
    })();
    var canvas = document.getElementById("confetti-canvas");
    if (canvas === null) {
      canvas = document.createElement("canvas");
      canvas.setAttribute("id", "confetti-canvas");
      canvas.setAttribute(
        "style",
        "display:block;z-index:999999;pointer-events:none"
      );
      document.body.appendChild(canvas);
      canvas.width = width;
      canvas.height = height;
      window.addEventListener(
        "resize",
        function () {
          canvas.width = window.innerWidth;
          canvas.height = window.innerHeight;
        },
        true
      );
    }
    var context = canvas.getContext("2d");
    while (particles.length < maxParticleCount)
      particles.push(resetParticle({}, width, height));
    streamingConfetti = true;
    if (animationTimer === null) {
      (function runAnimation() {
        context.clearRect(0, 0, window.innerWidth, window.innerHeight);
        if (particles.length === 0) animationTimer = null;
        else {
          updateParticles();
          drawParticles(context);
          animationTimer = requestAnimFrame(runAnimation);
        }
      })();
    }
  }

  function stopConfettiInner() {
    streamingConfetti = false;
  }

  function removeConfettiInner() {
    stopConfetti();
    particles = [];
  }

  function toggleConfettiInner() {
    if (streamingConfetti) stopConfettiInner();
    else startConfettiInner();
  }

  function drawParticles(context) {
    var particle;
    var x;
    for (var i = 0; i < particles.length; i++) {
      particle = particles[i];
      context.beginPath();
      context.lineWidth = particle.diameter;
      context.strokeStyle = particle.color;
      x = particle.x + particle.tilt;
      context.moveTo(x + particle.diameter / 2, particle.y);
      context.lineTo(x, particle.y + particle.tilt + particle.diameter / 2);
      context.stroke();
    }
  }

  function updateParticles() {
    var width = window.innerWidth;
    var height = window.innerHeight;
    var particle;
    waveAngle += 0.01;
    for (var i = 0; i < particles.length; i++) {
      particle = particles[i];
      if (!streamingConfetti && particle.y < -15) particle.y = height + 100;
      else {
        particle.tiltAngle += particle.tiltAngleIncrement;
        particle.x += Math.sin(waveAngle);
        particle.y +=
          (Math.cos(waveAngle) + particle.diameter + particleSpeed) * 0.5;
        particle.tilt = Math.sin(particle.tiltAngle) * 15;
      }
      if (particle.x > width + 20 || particle.x < -20 || particle.y > height) {
        if (streamingConfetti && particles.length <= maxParticleCount)
          resetParticle(particle, width, height);
        else {
          particles.splice(i, 1);
          i--;
        }
      }
    }
  }

  const rotationValues = [
    { minDegree: 0, maxDegree: 15, value: "ZONK" },
    { minDegree: 16, maxDegree: 54, value: "Iphone 14" },
    { minDegree: 55, maxDegree: 90, value: "10jt" },
    { minDegree: 91, maxDegree: 130, value: "ZONK" },
    { minDegree: 131, maxDegree: 162, value: "2,5 JT" },
    { minDegree: 163, maxDegree: 198, value: "Aerox" },
    { minDegree: 199, maxDegree: 234, value: "500k" },
    { minDegree: 235, maxDegree: 270, value: "5K" },
    { minDegree: 271, maxDegree: 306, value: "ZONK" },
    { minDegree: 307, maxDegree: 342, value: "20k" },
    { minDegree: 343, maxDegree: 360, value: "ZONK" },
  ];

  const data = [36, 36, 31, 36, 36, 36, 36, 36, 34, 36];

  var pieColors = [
    "#4ebbd8",
    "https://editorial.pxcrush.net/carsales/general/editorial/2022-mitsubishi-asx-es-xd-auto-2wd-my22-01.jpg",
    "#4ebbd2",
    "#063973",
    "#4ebbd4",
    "https://editorial.pxcrush.net/carsales/general/editorial/2022-mitsubishi-asx-es-xd-auto-2wd-my22-01.jpg",
    "#4ebbd6",
    "#063977",
    "https://editorial.pxcrush.net/carsales/general/editorial/2022-mitsubishi-asx-es-xd-auto-2wd-my22-01.jpg",
    "#063979",
  ];

  let myChart = new Chart(wheel, {
    plugins: [ChartDataLabels],

    type: "pie",
    data: {
      labels: [
        "10 JT",
        "Iphone 14",
        "ZONK",
        "20k",
        "ZONK",
        "5K",
        "500k",
        "Aerox",
        "2,5 JT",
        "ZONK",
      ],

      datasets: [
        {
          backgroundColor: pieColors,
          data: data,
        },
      ],
    },
    options: {
      responsive: true,
      animation: { duration: 0 },
      plugins: {
        tooltip: false,
        legend: {
          display: false,
        },

        datalabels: {
          anchor: "center",
          padding: 9,
          align: "end",
          color: "#ffffff",
          formatter: (_, context) =>
            context.chart.data.labels[context.dataIndex],
          font: function (context) {
            var width = context.chart.width;
            var size = Math.round(width / 32);
            return {
              size: size,
              weight: 500,
            };
          },
        },
      },
      elements: {
        arc: {
          borderWidth: 0,
        },
      },
      maintainAspectRatio: true,
    },
  });

  var audio = new Audio(location + "/assets/media/spin/spin.wav");
  var win = new Audio(location + "/assets/media/spin/tada.wav");
  var zonk = new Audio(location + "/assets/media/spin/lose.wav");

  const valueGenerator = (angleValue) => {
    for (let i of rotationValues) {
      if (angleValue >= i.minDegree && angleValue <= i.maxDegree) {
        audio.currentTime = 0;
        audio.pause();
        code.value = null;
        if (i.value == "ZONK") {
          setTimeout(function () {
            music("pause");
            zonk.play();
            zonk.playbackRate = 0.8;
            setTimeout(function () {
              zonk.pause();
              zonk.currentTime = 0;
              music("start");
            }, 3000);
          }, 100);
          $("#txt").html(`
            <img src='/assets/media/spin/zonk.png' />
          <p>Semoga Beruntung Lain Kali</p>`);
          finalValue.innerHTML = `Click Spin Untuk Memutar`;

          $("#kt_reward").modal("show");
        } else {
          finalValue.innerHTML = `Click Spin Untuk Memutar`;

          $("#kt_reward").modal("show");
          $("#txt").html(`
          <img src='/assets/media/spin/money.png' />
          <p>Selamat Anda Mendapat ${i.value}</p>`);
          setTimeout(function () {
            music("pause");
            startConfettiInner();
            win.play();
            win.playbackRate = 0.8;

            setTimeout(function () {
              zonk.pause();
              stopConfettiInner();
              music("start");
            }, 6000);
          }, 100);
        }
        btnSpin.disabled = false;
        inserSpin.disabled = false;
        break;
      }
    }
  };

  let count = 0;

  let resultValue = 101;

  inserSpin.addEventListener("click", (a) => {
    if (code.value.trim() != "") {
      var i = location + "cek";
      inserSpin.disabled = true;
      btnSpin.disabled = true;
      ajax(i, "POST", code.value).then((a) => {
        if ("error" == a.status) {
          inserSpin.disabled = false;
          btnSpin.disabled = false;
          code.value = null;
          code.setAttribute("placeholder", a.message);
        } else {
          let val = a.message;

          $("#kt_modal").modal("hide");

          audio.play();

          finalValue.innerHTML = `<p> Semoga Beruntung!</p>`;
          code.setAttribute("placeholder", "Masukkan Kode Voucher");
          let deg = 105;

          switch (val) {
            case "9SXhuok1M":
              deg = Math.floor(Math.random() * (341 - 308) + 308);
              break;
            case "A3x9uP01x":
              deg = Math.floor(Math.random() * (269 - 236) + 236);
              break;
            case "Pl87xT7j1":
              deg = Math.floor(Math.random() * (125 - 92) + 92);
              break;
          }

          console.log(deg);

          let rotationInterval = window.setInterval(() => {
            myChart.options.rotation = myChart.options.rotation + resultValue;

            myChart.update();

            if (myChart.options.rotation >= 360) {
              count += 1;
              resultValue -= 5;
              myChart.options.rotation = 0;
            } else if (count > 15 && myChart.options.rotation == deg) {
              valueGenerator(deg);
              clearInterval(rotationInterval);
              count = 0;
              resultValue = 101;
            }
          }, 10);
          code.value = null;
        }
      });
    } else {
      code.value = null;
      code.setAttribute("placeholder", "Masukkan Kode Voucher!!!");
    }
  });
})();
